#version 120

#include "/lib/colors.glsl"

varying vec4 texcoord;
varying vec3 lightVector;
varying vec3 sunlight_color;
varying vec3 ambient_color;
varying float handItemLight;
varying float eyeAdapt;
varying vec3 moonlight;
varying vec3 sunVec;
varying vec3 moonVec;
varying vec3 upVec;

varying float moonVisibility;

uniform vec3 upPosition;
uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform int worldTime;
uniform int heldItemId;
uniform int heldItemId2;
uniform float rainStrength;

uniform ivec2 eyeBrightnessSmooth;
uniform mat4 gbufferModelView;



//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
void main() {

	gl_Position = ftransform();
	gl_Position.xy = (gl_Position.xy);

	texcoord = gl_MultiTexCoord0;

	if (worldTime < 12700 || worldTime > 23250) {
		lightVector = normalize(sunPosition);
	}

	else {
		lightVector = normalize(moonPosition);
	}


	handItemLight = 0.0;
	
	float heldItemIdCombined = heldItemId + heldItemId2;
	
	if (heldItemId == 50 || heldItemId2 == 50 ) {
		// torch
		handItemLight = 0.5;
	}

	else if (heldItemId == 76 || heldItemId == 94 || heldItemId2 == 76 || heldItemId2 == 94) {
		// active redstone torch / redstone repeater
		handItemLight = 0.1;
	}

	else if (heldItemId == 89 || heldItemId2 == 89) {
		// lightstone
		handItemLight = 1.0;
	}

	else if (heldItemId == 10 || heldItemId == 11 || heldItemId == 51 || heldItemId2 == 10 || heldItemId2 == 11 || heldItemId2 == 51) {
		// lava / lava / fire
		handItemLight = 0.5;
	}

	else if (heldItemId == 91 || heldItemId2 == 91) {
		// jack-o-lantern
		handItemLight = 0.7;
	}

	else if (heldItemId == 327 || heldItemId2 == 327) {
		//lava bucket
		handItemLight = 1.5;
	}

		else if (heldItemId == 385 || heldItemId2 == 385) {
		//fire charger
		handItemLight = 0.2;
	}

		else if (heldItemId == 138 || heldItemId2 == 138) {
		//Beacon
		handItemLight = 1.0;
	}

		else if (heldItemId == 169 || heldItemId2 == 169) {
		//Sea lantern
		handItemLight = 1.0;
	}

	sunVec = normalize(sunPosition);
	moonVec = normalize(-sunPosition);
	upVec = normalize(upPosition);

	float MdotU = dot(moonVec,upVec);
	moonVisibility = pow(clamp(MdotU+0.1,0.0,0.1)/0.1,2.0);

	vec3 wUp = (gbufferModelView * vec4(vec3(0.0,1.0,0.0),0.0)).rgb;
	vec3 wS1 = (gbufferModelView * vec4(normalize(vec3(3.5,1.0,3.5)),0.0)).rgb;
	vec3 wS2 = (gbufferModelView * vec4(normalize(vec3(-3.5,1.0,3.5)),0.0)).rgb;
	vec3 wS3 = (gbufferModelView * vec4(normalize(vec3(3.5,1.0,-3.5)),0.0)).rgb;
	vec3 wS4 = (gbufferModelView * vec4(normalize(vec3(-3.5,1.0,-3.5)),0.0)).rgb;

	eyeAdapt = 1.;
	eyeAdapt = (2.0-min(sqrt(dot(((wUp) + (wS1) + (wS2) + (wS3) + (wS4))*2.,((wUp) + (wS1) + (wS2) + (wS3) + (wS4))*2.))/sqrt(3.)*2.,eyeBrightnessSmooth.y/255.0*0.2))*(1-rainStrength*0.5);

	moonlight =  vec3(0.7,0.7,1.0)/2.0 * 0.012;

	//float hour = worldTime/1000.0+6.0;
	//if (hour > 24.0) hour = hour - 24.0;
	
	sunlight_color = getSunlight(getTime(worldTime));
	
	ambient_color = getAmbient(getTime(worldTime));

}
