#version 120

//***************************ADJUSTABLE VARIABLES***************************//
//***************************ADJUSTABLE VARIABLES***************************//
//***************************ADJUSTABLE VARIABLES***************************//

//***************************GODRAYS***************************//

//#define GODRAYS
	const float exposure = 0.25;
	const float density = 1;
	const int NUM_SAMPLES = 10;			//increase this for better quality at the cost of performance
	const float grnoise = 1.0;		//amount of noise /0.0 is default

//***************************REFLECTIONS***************************//

#define REFLECTIONS
	#define WATER_REFLECTIONS
	#define REFLECTION_STRENGTH 0.875 //[0.125 0.25 0.375 0.5 0.625 0.75 0.875 1.0] //Strength
	#define RAIN_REFLECTIONS
	#define SPECULAR_REFLECTIONS

//***************************VISUALS***************************//

#define WATER_REFRACT		//Also includes stained glass and ice.
	#define REFRACT_MULT 10.0

//#define MOTIONBLUR
	#define MOTIONBLUR_AMOUNT 1.0
	//#define HQ_MOTIONBLUR			//High quality motionblur only enable one!
	#define LQ_MOTIONBLUR			//Low quality motionblur only enable one!

#define FOG

#define WATER_DEPTH_FOG

//***************************CLOUDS***************************//

#define Clouds	//2d clouds

//#define VOLUMETRIC_CLOUDS //3d clouds. WARNING!!! VERY FPS INTENSIVE. Might also bug a little bit.

//***************************VISUALS***************************//

#define Stars

//#define COLOR_CORRECTION
	#define COLOR_R_MULT 1.0 //[0.25 0.5 0.75 1.0 1.25 1.5 1.75 2.0]
	#define COLOR_G_MULT 1.0 //[0.25 0.5 0.75 1.0 1.25 1.5 1.75 2.0]
	#define COLOR_B_MULT 1.0 //[0.25 0.5 0.75 1.0 1.25 1.5 1.75 2.0]

//***************************VOLUMETRIC LIGHT***************************//
#define VOLUMETRIC_LIGHT
	#define VL_MULT 					1.0	//[0.25 0.5 0.75 1.0 1.25 1.5 1.75 2.0 2.25 2.5 2.75 3.0 3.25 3.5 3.75 4.0]	// Simple multiplier
	#define VL_STRENGTH_DAY 			1.0	//[0.25 0.5 0.75 1.0 1.25 1.5 1.75 2.0 2.25 2.5 2.75 3.0 3.25 3.5 3.75 4.0]	// Strength of day time
	#define VL_STRENGTH_NIGHT 			1.0	//[0.25 0.5 0.75 1.0 1.25 1.5 1.75 2.0 2.25 2.5 2.75 3.0 3.25 3.5 3.75 4.0] // Strength of night time
	#define VL_STRENGTH_SUNSET_SUNRISE 	1.0	//[0.25 0.5 0.75 1.0 1.25 1.5 1.75 2.0 2.25 2.5 2.75 3.0 3.25 3.5 3.75 4.0] // Strength of sunset and sunrise time
	
//***************************END OF ADJUSTABLE VARIABLES***************************//
//***************************END OF ADJUSTABLE VARIABLES***************************//
//***************************END OF ADJUSTABLE VARIABLES***************************//

const bool 		gcolorMipmapEnabled 	= true; //gcolor texture mipmapping
const bool 		gaux1MipmapEnabled 	= true; //gaux1 texture mipmapping
const bool 		shadowHardwareFiltering0 = true;

//don't touch these lines if you don't know what you do!
const int maxf = 3;				//number of refinements
const float stp = 1.0;			//size of one step for raytracing algorithm
const float ref = 0.1;			//refinement multiplier
const float inc = 2.0;			//increasement factor at each step

varying vec4 texcoord;
varying vec3 sunlight;
varying vec3 lightVector;
varying vec3 moonVec;
varying vec3 sunVec;
varying vec3 upVec;
varying vec3 ambient_color;
varying vec3 moonlight;
varying vec3 cloudColor;
varying float moonVisibility;

uniform sampler2DShadow shadowtex0;
uniform sampler2D noisetex;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D gcolor;
uniform sampler2D gnormal;
uniform sampler2D composite;
uniform sampler2D gaux3;
uniform sampler2D gaux2;
uniform sampler2D gaux1;
uniform mat4 gbufferProjection;
uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;
uniform mat4 gbufferPreviousProjection;
uniform mat4 shadowProjection;
uniform mat4 shadowModelView;
uniform vec3 sunPosition;
uniform vec3 cameraPosition;
uniform vec3 previousCameraPosition;
uniform float far;
uniform float near;
uniform float viewWidth;
uniform float viewHeight;
uniform float rainStrength;
uniform float wetness;
uniform float frameTimeCounter;
uniform ivec2 eyeBrightnessSmooth;
uniform int isEyeInWater;
uniform int worldTime;

#include "lib/waterBump.glsl"
#include "lib/colorRange.glsl"

float comp = 1.0-near/far/far;			//distance above that are considered as sky

float timefract = worldTime;

//Raining
float rainx = clamp(rainStrength, 0.0f, 1.0f)/1.0f;
float wetx  = clamp(wetness, 0.0f, 1.0f);

//Calculate Time of Day
float TimeSunrise  = ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0) + (1.0 - (clamp(timefract, 0.0, 4000.0)/4000.0));
float TimeNoon     = ((clamp(timefract, 0.0, 4000.0)) / 4000.0) - ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0);
float TimeSunset   = ((clamp(timefract, 8000.0, 12000.0) - 8000.0) / 4000.0) - ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0);
float TimeMidnight = ((clamp(timefract, 12000.0, 12750.0) - 12000.0) / 750.0) - ((clamp(timefract, 23000.0, 24000.0) - 23000.0) / 1000.0);

float transition_fading = 1.0-(clamp((timefract-12000.0)/300.0,0.0,1.0)-clamp((timefract-13000.0)/300.0,0.0,1.0) + clamp((timefract-22800.0)/200.0,0.0,1.0)-clamp((timefract-23400.0)/200.0,0.0,1.0));

float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;

vec4 aux = texture2D(gaux1, texcoord.st);

vec3 fogclr;
vec3 fogclr2;

float pixeldepth = texture2D(depthtex1,texcoord.xy).x;
float pixeldepth2 = texture2D(depthtex0,texcoord.xy).x;
vec3 normal = texture2D(gnormal, texcoord.st).rgb * 2.0 - 1.0;
vec3 normal2 = (texture2D(composite, texcoord.st).rgb * 2.0 - 1.0);


float sky_lightmap = texture2D(gaux1,texcoord.xy).r;
float reflectionSkyLight = clamp(pow(sky_lightmap, 4.0) * 2.0, 0.0, 1.0);

float iswet = wetness*pow(sky_lightmap,10.0);

vec3 specular = pow(texture2D(gaux3,texcoord.xy).rgb,vec3(2.2));
float specmap = float(aux.a > 0.7 && aux.a < 0.72) + (specular.r+specular.g*(iswet));
vec3 color = texture2D(gcolor,texcoord.xy,0).rgb * MAX_COLOR_RANGE;

int iswater = int(aux.g > 0.04 && aux.g < 0.07);
int land2 = int(aux.g < 0.03);
int hand  = int(aux.g > 0.75 && aux.g < 0.85);
float istransparent = float(aux.g > 0.4 && aux.g < 0.42);
float islava = float(aux.g > 0.50 && aux.g < 0.55);

vec3 renderGaux2(vec3 color, vec2 pos){
	return mix(color,texture2D(gaux2, pos.st).rgb * 1.5 * color,clamp(texture2D(gaux2, pos.st).a * 1.25,0.0,1.0));
}

vec3 nvec3(vec4 pos) {
    return pos.xyz/pos.w;
}

vec4 nvec4(vec3 pos) {
    return vec4(pos.xyz, 1.0);
}

float cdist(vec2 coord) {
	return max(abs(coord.x-0.5),abs(coord.y-0.5))*2.0;
}

float ld(float dist) {
    return (2.0 * near) / (far + near - dist * (far - near));
}

float getDepth(float depth) {
    return 2.0 * near * far / (far + near - (2.0 * depth - 1.0) * (far - near));
}

float convertVec3ToFloat(in vec3 invec){

	float mixing;
		mixing += invec.x;
		mixing += invec.y;
		mixing += invec.z;
		mixing /= 3.0;

	return mixing;
}

vec3 convertScreenSpaceToWorldSpace(vec2 co, float depth) {
    vec4 fragposition = gbufferProjectionInverse * vec4(vec3(co, depth) * 2.0 - 1.0, 1.0);
    fragposition /= fragposition.w;
    return fragposition.xyz;
}

float subSurfaceScattering(vec3 vec,vec3 pos, float N) {

return pow(max(dot(vec,normalize(pos))*0.5+0.5,0.0),N)*(N+1)/6.28;

}

float noisepattern(vec2 pos, float sample) {
	float noise = abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f));

	noise *= sample;
	return noise;
}



#ifdef Clouds

vec3 drawCloud(vec3 fposition, vec3 color, float mult) {
			
			float Size = 1.2;
			vec3 sVector = normalize(fposition.xyz);
			float cosT = max(dot(normalize(sVector),upVec),0.0);
			vec3 tpos = vec3(gbufferModelViewInverse * vec4(sVector,0.0));
			vec3 wvec = normalize(tpos.xyz);
			vec3 wVector = normalize(tpos.xyz);
			vec3 scattering = vec3(subSurfaceScattering(lightVector, fposition, 30.0)) * 0.5 * (1.0 - TimeMidnight);

			vec3 cloudCol = pow(sunlight.rgb * 2.4,vec3(3.4))*(TimeSunrise+TimeSunset);
				cloudCol.rgb += (cloudColor.rgb * 2.0)*(TimeNoon);
				cloudCol.rgb += (moonlight.rgb * 1000.0)*(TimeMidnight);
				cloudCol.rgb +=	pow(sunlight.rgb * 1.5,vec3(3.0)) * (1-transition_fading);

			float totalcloud = 0.0;

			float height = (600.0)/(wVector.y);
			vec2 wind = vec2(abs(frameTimeCounter/20000.-0.5),abs(frameTimeCounter/20000.-0.5))+vec2(0.5);
			//wind *= 10.0;

			vec3 intersection;
			float density;
			float d1;

			int Steps = 8;
			float weight;

			for (int i = 0; i < Steps; i++) {
				intersection = wVector.xyz * (height - i * 70  * Size / Steps); 			//curved cloud plane

				vec2 coord1 = (intersection.xz+cameraPosition.xz*2.5)/200000;
				coord1 += (wind.xy);
				vec2 coord = (coord1.xy/Size);

				float noise = texture2D(noisetex,coord.xy - wind.xy * 0.5).x;
				noise += texture2D(noisetex,coord.xy*3.5).x/3.5;
				noise += texture2D(noisetex,coord.xy*6.125).x/6.125;
				noise += texture2D(noisetex,coord.xy*12.25).x/12.25;
				//noise += texture2D(noisetex,coord.xy*24.5).x/12.25;
				noise *= clamp(texture2D(noisetex,coord.xy / 2.1).x * 2.5,0.0,1.0); // not robins clouds tbh
				noise *= (pow(noise, 1.41421));
				noise *= 20.0;

				float cl = max(noise-0.9,0.0);
				cl = max(cl,0.)*0.05 * (1.0 - rainx * 0.9);
				density = max(1-cl*2.5,0.)*max(1-cl*2.5,0.) / 11.0 / 3.0;
				density *= 2.0;

				totalcloud += density;
				if (totalcloud > (1.0 - 1.0 / Steps + 0.1)) break;
				weight ++;

			}

			cloudCol.rgb = mix(cloudCol.rgb*pow(1-density, 2.0),vec3(cloudCol.rgb*0.125),pow(density, 2.0)) * 2.0;

			//cloudCol.rgb += pow(sunlight.rgb * mix(3.0,2.4,TimeSunset + TimeSunrise),vec3(mix(3.4 - (1.0 * (1.0 - transition_fading)),1.0,TimeNoon)))* (50*(pow(1-density, 100.0 * (1-(1-transition_fading * 0.5))))) * mix(1.0,0.1,1.0 - transition_fading) * 1.5 * (1-(TimeMidnight * transition_fading)) * (1-rainx);
			cloudCol.rgb += pow(sunlight.rgb * mix(3.0,2.4,TimeSunset + TimeSunrise),vec3(mix(3.4 - (1.0 * (1.0 - transition_fading)),1.0,TimeNoon))) * 25 * (1- TimeMidnight);
			cloudCol.rgb += moonlight.rgb * (50*(pow(1-density, 14.0))) * 70 * transition_fading * (1-rainx);
			cloudCol.rgb *= 0.5;

			cloudCol.rgb *= (1- (0.5 * TimeMidnight * transition_fading));
			cloudCol.rgb *= (1+ TimeNoon);
			cloudCol.rgb *= (scattering * pow(1-density, 1.0)) + 1.0;
			cloudCol.rgb = mix(cloudCol.rgb,cloudCol.rgb * 0.5,pow(1-density, 100.0) * (1-scattering));

			totalcloud = min(totalcloud / weight,1.0);
			//totalcloud = mix(totalcloud,0.0,pow(1-density, 100.0));
			return pow(mix(pow(color.rgb, vec3(2.2)), pow(cloudCol.rgb * mult * 0.0875 * (1.0 - rainx * 0.8) * 0.05, vec3(2.2)),clamp(totalcloud * pow(cosT,1.2) * 10.0, 0.0, 1.0)), vec3(1.0/2.2));
	}
#endif

#ifdef Stars
	vec3 drawStar(vec3 fposition,vec3 color) {
		float volumetric_cone = pow(max(dot(normalize(fposition),moonVec),0.0),200.0);
		vec3 sVector = normalize(fposition);
		float cosT = dot(sVector,upVec);

		//star generation

		vec3 tpos = vec3(gbufferModelViewInverse * vec4(fposition,1.0));
		vec3 wVector = normalize(tpos);
		vec3 intersection = wVector*(50.0/(wVector.y));
		vec2 coord = (intersection.xz)/256.0 + 0.1;
		float noise = texture2D(noisetex,fract(coord.xy/2.0)).x;
		noise += texture2D(noisetex,fract(coord.xy)).x/2.0;
		float star = max(noise-1.3,0.0);
		star = star * max(cosT,0.0) * 2.0 * TimeMidnight * (1-rainx);

		vec3 sum = vec3(1.0, 1.0, 1.0)*(1-rainx) * (1-volumetric_cone);

		vec3 s = mix(color,sum,star);
		return s;
	}
#endif

float getRainPuddles(float sizeMult, float addTime){


	vec3 pPos = vec3(texcoord.st, texture2D(depthtex0, texcoord.st).r);
	pPos = nvec3(gbufferProjectionInverse * nvec4(pPos * 2.0 - 1.0));
	vec4 pUw = gbufferModelViewInverse * vec4(pPos,1.0);
	vec3 worldPos = (pUw.xyz + cameraPosition.xyz);

	vec2 coord = (worldPos.xz/10000 * sizeMult);

	float rainPuddles = texture2D(noisetex, fract(coord.xy) + addTime * 2.0).x;
	rainPuddles += texture2D(noisetex, fract(coord.xy*2) - addTime).x;
	rainPuddles += texture2D(noisetex, fract(coord.xy*4) + addTime).x;
	rainPuddles += texture2D(noisetex, fract(coord.xy*8) - addTime * 2.0).x;

	float strength = max(rainPuddles-1.9,0.0);
	float dL = 0.5;
	float L = (1.0 - (pow(dL,strength)));

	return L;
}

float getnoise(vec2 pos) {
	return abs(fract(sin(dot(pos ,vec2(18.9898f,28.633f))) * 4378.5453f));
}

float refractmask(vec2 coord, float lod){

	float mask = texture2D(gaux1, coord.st, lod).g;
	
	if (iswater > 0.9){
		mask = float(mask > 0.04 && mask < 0.07);
	}
	
	if (istransparent > 0.9){
		mask = float(mask > 0.4 && mask < 0.42);
	}
	
	return mask;

}

#ifdef VOLUMETRIC_LIGHT
	vec3 vlColor(vec3 fogcolor,in vec3 color, in vec2 pos, vec3 fragpos) {

		float VolumeSample = 0.0;
		float vlWeight = 0.0;
		
		float depth = ld(pixeldepth);
		
		for (float i = -1.0; i < 1.0; i++){
			for (float j = -1.0; j < 1.0; j++){
				
				vec2 offset = vec2(i,j) / vec2(viewWidth, viewHeight);
				
				float depth2 = ld(texture2D(depthtex1, texcoord.st + offset * 8.0).x);
				
				float weight = pow(1.0 - abs(depth - depth2) * 10.0, 32.0);
					weight = max(0.1e-8, weight);
					
				VolumeSample += texture2D(gcolor, pos.xy + offset * 4.0, 1.5).a * weight;
				
				vlWeight += weight;
			}
		}
		
		VolumeSample /= vlWeight;

		float Glow = pow(max(dot(normalize(fragpos.xyz),lightVector),0.0),2.5*15);
		float vlGlow = (1.5-Glow*-(2.5*(1-TimeNoon*-5)*(1+(TimeSunrise + TimeSunset)*15.)*(0.1))) * 0.5;
		
		float atmosphere = pow(max(dot(normalize(fragpos.xyz),lightVector),0.0),2.0);

		vec3 vlDay = vec3(sunlight.rgb) * VL_STRENGTH_DAY * TimeNoon * 0.2 * (1.0 - rainx);
		vec3 vlNight = vec3(moonlight.rgb) * 20 * (VL_STRENGTH_NIGHT * moonVisibility) * (1.0 - rainx);
		vec3 vlRain = vec3(0.5) * rainx;
		vec3 vlSSSR = vec3(sunlight.rgb) * (VL_STRENGTH_SUNSET_SUNRISE * (TimeSunrise + TimeSunset * 0.5));
		vec3 combined = (vlDay.rgb + vlNight.rgb + vlRain + vlSSSR.rgb);
		
		float vlWeather = (1.0 - rainx) + (TimeSunrise * 0.0 + TimeNoon * 1.0 + TimeSunset * 0.5 + TimeMidnight * 0.8) * rainx;
		
		vec3 atmosphereColor = fogcolor.rgb * (1.0 - atmosphere);

		vec3 vlcolor = combined.rgb;
		//vlcolor = mix(vlcolor.rgb,pow(vlcolor.rgb,vec3(1.5)) * 2.2,(TimeSunrise + TimeSunset));
		
		atmosphereColor.rgb = mix(atmosphereColor.rgb, vlcolor.rgb, 0.7);
		vlcolor.rgb *= atmosphere;
		vlcolor.rgb += atmosphereColor.rgb;
		vlcolor.rgb *= (0.1 + (vlGlow));

		vlcolor.rgb = pow(mix(pow(color.rgb, vec3(2.2)), pow(vlcolor.rgb, vec3(2.2)), VolumeSample / 5.0 * VL_MULT * vlWeather * (1-isEyeInWater) * transition_fading * (1.0 - TimeMidnight * 0.9)), vec3(1.0/2.2));
		return vlcolor.rgb;
	}
#endif


float dynamicExposure() {
		return clamp((-eyeBrightnessSmooth.y+230)/100.0,0.0,1.0);
}

vec3 getRainFogColor(){
		vec3 rainfogclr = vec3(0.1,0.095,0.1)*rainx * (TimeSunrise + TimeNoon + TimeSunset + TimeMidnight * 0.2);

		fogclr2 = rainfogclr*16.0*rainx;
		fogclr2 -= fogclr2*0.8*rainx;
		
		return fogclr2;
}

#ifdef FOG

vec3 getFog(vec3 color, bool land, bool land2, vec2 pos){

	vec3 fragposFog = vec3(pos.st, texture2D(depthtex0, pos.st).r);
	fragposFog = nvec3(gbufferProjectionInverse * nvec4(fragposFog * 2.0 - 1.0));

	vec4 worldposition = vec4(0.0);
		 worldposition = gbufferModelViewInverse * vec4(fragposFog,1.0);
	float horizon = (worldposition.y - (pos.y-cameraPosition.y));

	float calcHeight = (max(pow(max(1.5 - horizon/100.0, 0.0), 1.0)-0.0, 0.0));

	float volumetric_cone = pow(max(dot(normalize(fragposFog),lightVector),0.0),2.5)*transition_fading;
	float volumetric_cone2 = pow(max(dot(normalize(fragposFog),lightVector),0.0),10.0*400.0);
	float volumetric_cone3 = pow(max(dot(normalize(fragposFog),lightVector),0.0),10.0*1000.0)*transition_fading;
	float norain = 1.0-rainx;

		float fog = exp(-pow(sqrt(dot(fragposFog,fragposFog))/far*0.6*(1- dynamicExposure())*(1-(TimeSunrise+TimeSunset)*0.4) ,2.0));
		float fog2 = exp(-pow(sqrt(dot(fragposFog,fragposFog))/90*(1-dynamicExposure()*.8) ,2.0));
		float fog3 = exp(-pow(sqrt(dot(fragposFog,fragposFog))/140*(1-dynamicExposure()) ,2.0));
		float fogfactor =  clamp(fog*1.2,0.0,1.0);
		float fogfactor2 =  clamp(fog2*1.2,0.0,1.0);
		float fogfactor3 =  clamp(fog3*1.2,0.0,1.0);

		fogclr = mix(color.rgb,ambient_color,0.6 + clamp((20000*TimeMidnight), 0.0, 0.25))*(1.0-rainx)*(1.0-TimeMidnight*0.87);
		fogclr = clamp(mix(fogclr, ambient_color, (1-TimeMidnight)*(1+TimeSunrise*0.25)*(1+TimeNoon*.5)),0.0,1.0);
		//fogclr.g -= fogclr.g*0.15;
		//fogclr.rb -= fogclr.rb*0.1*(TimeSunrise+TimeSunset);
		
		fogclr2 = getRainFogColor();

		//glow

		//fogclr += pow(sunlight,vec3(2.2)) * volumetric_cone*transition_fading*(1.0-TimeMidnight)*(1.0-TimeNoon)*(1.0-rainx*0.4)*2.5;
		//fogclr += fogclr * 0.05 * volumetric_cone*2*transition_fading*TimeMidnight*(1.0-rainx)*1.0;
		
		fogclr = clamp(fogclr,0.0,1.0);
		color.rgb = pow(color.rgb, vec3(2.2));
		
		if (isEyeInWater > .9) {
			} else {

		if (land) {
			color.rgb = mix(color.rgb,pow(fogclr, vec3(2.2)),(1-fogfactor)*0.5*(1-clamp(calcHeight,0.0,1.0))*.5*(1- dynamicExposure()) * (TimeSunrise + TimeNoon + TimeSunset));
		}

		color.rgb = mix(color.rgb,pow(fogclr2, vec3(2.2)),(1-fogfactor2)*rainx);


		//altitude fog
		if (land) {
				color.rgb = mix(color.rgb,pow(fogclr, vec3(2.2)),clamp((1-fogfactor)*(1-rainx)*(1-TimeMidnight)*(clamp((calcHeight) * 0.6, 0.0, 1.0)),0.0,1.0) * (TimeSunrise + TimeNoon + TimeSunset));

				calcHeight = (max(pow(max(0.76 - horizon/300.0, 0.0), 8.0)-0.0, 0.0));
				color.rgb  = mix(color.rgb,pow(clamp(fogclr * 1.5, 0.0, 1.0), vec3(2.2)),clamp(3.0*(clamp((calcHeight) * 100, 0.0, 1.0))*(TimeMidnight)*(1- rainx)*(1-TimeSunrise)*(transition_fading)*(1-fogfactor3),0.0,1.0) * (TimeSunrise + TimeNoon + TimeSunset));
			}

	}
	return pow(color, vec3(1.0/2.2));
}
#endif

vec3 getSkyColor() {

	////////////////////////////////////////////////////////////////////////////////

	vec3 sclr = vec3(87.5,90,150)/1500*TimeNoon*(1.0-rainx);
		 sclr += vec3(15,15,25)/200*(TimeSunrise+TimeSunset)*transition_fading*(1.0-rainx);
		 sclr += vec3(15,15,25)/300*(1-transition_fading)*(TimeSunrise + TimeSunset)*(1.0-rainx);
		 sclr += vec3(ambient_color.r/5.0,ambient_color.g/5.0 - 
		 (ambient_color.g * 0.03),ambient_color.b/5.0)/3.4*moonVisibility*transition_fading*(1.0-rainx);
		 
		 sclr += vec3((moonlight*0.5)*7.5)*(1-transition_fading)*(1-(TimeSunrise + TimeSunset))*(1.0-rainx);
		 //sclr *= 2.0;
		 //sclr /= 2.5;
		 sclr *= (1.0-TimeSunrise*0.35)*(1.0-TimeSunset*0.35);
		 sclr += vec3(0.1,0.095,0.1)*1.5*rainx*(1-moonVisibility);
		 sclr = mix(sclr, vec3(ambient_color / 21.0), rainx * (TimeMidnight + (1.0 - transition_fading)));

	return sclr;
}

#ifdef REFLECTIONS

float sunSpec(vec3 lvector, vec3 fpos, vec3 normal){

	vec3 r = normalize(reflect(normalize(fpos), normal));

	return pow(clamp(dot(r,lvector),0.0,1.0),1250.0) * 50.0;
}

vec4 raytrace(vec3 fragpos, vec3 normal, vec3 fogclr, vec3 rvector, float fresnel) {
    vec4 color = vec4(0.0);
    vec3 start = fragpos;
    vec3 vector = stp * rvector;
    vec3 oldpos = fragpos;
		
    fragpos += vector;
	vec3 tvector = vector;
    int sr = 0;


	    for(int i=0;i<18;i++){
        vec3 pos = nvec3(gbufferProjection * nvec4(fragpos)) * 0.5 + 0.5;
        if(pos.x < 0 || pos.x > 1 || pos.y < 0 || pos.y > 1 || pos.z < 0 || pos.z > 1.0) break;
        vec3 spos = vec3(pos.st, texture2D(depthtex1, pos.st).r);
        spos = nvec3(gbufferProjectionInverse * nvec4(spos * 2.0 - 1.0));
        float err = distance(fragpos.xyz,spos.xyz);
        if(err < pow(sqrt(dot(vector,vector))*pow(sqrt(dot(vector,vector)),0.11),1.1)*1.1){

                sr++;
                if(sr >= maxf){

					bool land = texture2D(depthtex0, pos.st).r < comp;
                    float border = clamp(1.0 - pow(cdist(pos.st), 10.0), 0.0, 1.0);
                    color = texture2D(gcolor, pos.st) * MAX_COLOR_RANGE;

						color.a = 1.0;

						#ifdef FOG
							color.rgb = getFog(color.rgb, land, land, pos.st);
						#endif
						
						//color.rgb *= fresnel;

						color.rgb = land ? color.rgb : fogclr*(1.0-isEyeInWater);

						color.a *= border;
                    break;
                }
				tvector -=vector;
                vector *=ref;


}
        vector *= inc;
        oldpos = fragpos;
        tvector += vector;
		fragpos = start + tvector;
    }

    return color;
}

vec3 getSkyReflection(vec3 reflectedVector) {

	////////////////////////////////////////////////////////////////////////////////

	float volumetric_cone = pow(max(dot(normalize(reflectedVector),sunVec),0.0),2.5);
	float volumetric_cone2 = pow(1-max(dot(normalize(reflectedVector),upVec),0.0),2.5);

	vec3 sclr = vec3(50,80,150)/1500*TimeNoon*(1.0-rainx);
		 sclr += sclr*3.0*volumetric_cone*volumetric_cone2;
		 sclr += vec3(15,15,25)/200*(TimeSunrise+TimeSunset)*transition_fading*(1.0-rainx);
		 sclr += vec3(15,15,25)/300*(1-transition_fading)*(TimeSunrise + TimeSunset)*(1.0-rainx);
		 sclr += vec3(25,15,5)/100*(TimeSunrise+TimeSunset)*transition_fading*volumetric_cone*(1.0-rainx);
		 sclr += vec3(88,22,0)/(200)/17.5*volumetric_cone*(1-transition_fading)*(1.0-rainx);
		 sclr += sclr*2.0*volumetric_cone2;
		 sclr += vec3(ambient_color.r/5.0,ambient_color.g/5.0 - (ambient_color.g * 0.03),ambient_color.b/5.0)/2.7*moonVisibility*transition_fading*(1.0-rainx);
		 sclr += vec3((moonlight*0.5)*7.5)*(1-transition_fading)*(1-(TimeSunrise + TimeSunset))*(1.0-rainx);
		 sclr += sclr*volumetric_cone2*0.75;
		 //sclr /= 2.0;
		 sclr *= (1.0-TimeSunrise*0.35)*(1.0-TimeSunset*0.35);
		 sclr = mix(sclr, getRainFogColor(), rainx);
		 //sclr += vec3(0.1,0.095,0.1)*1.43*rainx*(1-moonVisibility);
		 //sclr = mix(sclr, vec3(ambient_color), rainx * (TimeMidnight));

	////////////////////////////////////////////////////////////////////////////////

	vec3 getSky;

	////////////////////////////////////////////////////////////////////////////////

	#ifdef Clouds
		vec3 addClouds = drawCloud(reflectedVector.xyz,sclr.rgb,1.0 / 2.0);
	#else
		vec3 addClouds = vec3(0);
	#endif

	#ifdef Stars
		vec3 addStars = drawStar(reflectedVector.xyz,sclr.rgb);
	#else
		vec3 addStars = vec3(0);
	#endif

	////////////////////////////////////////////////////////////////////////////////

		#ifdef Clouds
			getSky += (addClouds)*(1-isEyeInWater);
		#else
			getSky += (sclr)*(1-isEyeInWater);
		#endif

		#ifdef Stars
			getSky += (addStars)*(1-isEyeInWater);
		#else
			getSky += (sclr)*(1-isEyeInWater);
		#endif

	////////////////////////////////////////////////////////////////////////////////

	return getSky * 1.0;
}

#endif

#ifdef GODRAYS
	vec3 getGodrays(vec3 fragpos) {

	  vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
				 tpos = vec4(tpos.xyz/tpos.w,1.0);
		vec2 pos1 = tpos.xy/tpos.z;
		vec2 lightPos = pos1*0.5+0.5;
		
		vec4 grWeight = vec4(0.0);
			grWeight.x = pow(float(NUM_SAMPLES),(1.0));
			grWeight.y = 0.9/grWeight.x;
			grWeight.z = (grWeight.x-1) * 0.5;
			grWeight.w = 0.0;
		
		const float sigma = 0.5;

		float truepos = sunPosition.z/abs(sunPosition.z);

		vec3 rainc = mix(vec3(1.),fogclr2*1.5,rainx);
		vec3 lightColor = mix(sunlight*(1-moonVisibility)*rainc,moonlight*25*moonVisibility,(truepos));

		if (isEyeInWater < 0.9) {
		vec2 deltaTextCoord = (texcoord.st - lightPos.xy)*grWeight.y*density;
		vec2 textCoord = texcoord.st;
		float illuminationDecay = 1.0;
		float noise = noisepattern(textCoord,1.0);
		float gr = 0.0;
		float avgdecay = 0.0;

		float Visibility = pow(max(dot(normalize(fragpos),lightVector),0.0),4.5);

		for(int i=0; i < grWeight.x ; i++)
		{

							textCoord -= deltaTextCoord;

					float dist = (i-float(grWeight.z))/grWeight.z;
					float weight = exp(-(dist*dist)/(2.0*sigma));

					float sample = step(texture2D(gaux1, textCoord +deltaTextCoord * noise * grnoise).r,0.0)*weight;

					grWeight.w += weight;
					gr += sample;

		}
		vec3 grC = mix(lightColor.rgb,fogclr2.rgb,rainx)*exposure*(gr/grWeight.w)*(1.0 - rainx*0.8)*Visibility * transition_fading * (1-isEyeInWater);
		grC = pow(grC.rgb, vec3(2.2));
		color.rgb = pow(color.rgb, vec3(2.2));
		color.xyz = pow((1-(1-color.xyz/48.0)*(1-grC.xyz/48.0))*48.0, vec3(0.4545));
		}
	return color.rgb;
	}
#endif

#ifdef MOTIONBLUR
	vec3 getMotionblur(vec4 previousPosition, vec4 currentPosition, float hand) {

		if (isEyeInWater > 0.9) {
			} else if (hand > 0.9) {
				} else {
					#ifdef LQ_MOTIONBLUR
						vec2 velocity = (currentPosition.xyz - previousPosition.xyz).st * (0.05*MOTIONBLUR_AMOUNT);
					#endif
					#ifdef HQ_MOTIONBLUR
						vec2 velocity = (currentPosition - previousPosition).st * (0.01*MOTIONBLUR_AMOUNT);
					#endif


					int samples = 1;

					vec2 coord = texcoord.st + velocity;

					coord = clamp(coord, 1.0 / vec2(viewWidth, viewHeight), 1.0 - 1.0 / vec2(viewWidth, viewHeight));
					//float dither = find_closest(texcoord.st,1.0);
					#ifdef HQ_MOTIONBLUR
						for (int i = 0; i < 16; ++i, coord += velocity) {
							if (coord.s > 1.0 || coord.t > 1.0 || coord.s < 0.0 || coord.t < 0.0) {
								break;
							}
								color += texture2D(gcolor, coord).rgb * MAX_COLOR_RANGE;
								++samples;
						}
						#endif
							#ifdef LQ_MOTIONBLUR
							for (int i = 0; i < 4; ++i, coord += velocity) {
							if (coord.s > 1.0 || coord.t > 1.0 || coord.s < 0.0 || coord.t < 0.0) {
								break;
							}
								color += texture2D(gcolor, coord).rgb * MAX_COLOR_RANGE;
								++samples;
						}
					#endif

					color = (color/1.0)/samples;
				}
		return color;
	}
#endif

#ifdef WATER_REFRACT

	void waterRefractCoord(out float maskCoord1, out float maskCoord2, out float maskCoord3, out vec2 coord1, out vec2 coord2, out vec2 coord3, out vec3 refraction){
	
		vec3 fragpos = vec3(texcoord.st, texture2D(depthtex0, texcoord.st).r);
		fragpos = nvec3(gbufferProjectionInverse * nvec4(fragpos * 2.0 - 1.0));

		vec4 worldposition = vec4(0.0);
		 worldposition = gbufferModelViewInverse * vec4(fragpos,1.0);

		vec3 posxz = worldposition.xyz + cameraPosition.xyz;
		
		float getAngle = dot(normal2, normalize(fragpos));
		float amount = clamp(pow(1.0 + getAngle, 1.0),0.0,1.0);
		amount = pow(amount,1.0 - getAngle);

		float dispersion = 0.3 * amount;
		
		#define composite
		
		refraction = getWaveHeightFlat(posxz, iswater, istransparent);

		float depth = getDepth(pixeldepth);
		float depth2 = getDepth(pixeldepth2);

		float wDepth = depth - depth2;

		float refMult = 1.0;
			refMult = clamp(wDepth,0.0,1.0);
			refMult /= (depth2);
			refMult *= (REFRACT_MULT/75);

		dispersion *= refMult;

		coord1 = texcoord.st + refraction.xy * refMult;
		coord2 = texcoord.st + refraction.xy * (refMult + dispersion);
		coord3 = texcoord.st + refraction.xy * (refMult + dispersion * 2.0);

		coord1 = (coord1);
		coord2 = (coord2);
		coord3 = (coord3);

		refraction.xy *= refMult;

		maskCoord1 = refractmask(coord1, 0.0);
		maskCoord2 = refractmask(coord2, 0.0);
		maskCoord3 = refractmask(coord3, 0.0);
	}


#endif

vec2 refractionTexcoord(){

	vec2 coord1;
	vec2 coord2;
	vec2 coord3;

	float maskCoord1;
	float maskCoord2;
	float maskCoord3;

	vec3 refraction;

		#ifdef WATER_REFRACT
			waterRefractCoord(maskCoord1, maskCoord2, maskCoord3, coord1, coord2, coord3, refraction);
			vec2 getCustomTc = texcoord.st + refraction.st;
			float refractMask = refractmask(getCustomTc, 0.0);

			getCustomTc -= refraction.st * (1-refractMask);
			getCustomTc = mix(getCustomTc, texcoord.st, hand);
		#else
			vec2 getCustomTc = texcoord.st;
		#endif
		
		return getCustomTc;

}


vec2 blurOffsets[12] = vec2[12] (
		vec2(0.1, 0.0),
		vec2(0.05, 0.08660000000000001),
		vec2(-0.05, 0.08660000000000001),
		vec2(-0.1, 0.0),
		vec2(-0.05, -0.08660000000000001),
		vec2(0.05, -0.08660000000000001),
		vec2(0.2, 0.0),
		vec2(0.1, 0.17320000000000002),
		vec2(-0.1, 0.17320000000000002),
		vec2(-0.2, 0.0),
		vec2(-0.1, -0.17320000000000002),
		vec2(0.1, -0.17320000000000002));

vec3 waterBlur (vec2 uv, vec3 fragpos) {
	
	vec4 worldposition = gbufferModelViewInverse * vec4(fragpos,1.0);
	vec3 posxz = worldposition.xyz + cameraPosition.xyz;
	float depth = getDepth(texture2D(depthtex1, texcoord.st).x);
	float depth2 = getDepth(pixeldepth2) * 1.0;
	float wDepth = clamp((depth - depth2), 0.0, 1.0);
	float mult = mix(0.03,0.05,iswater*1.0) * clamp(0.5 - dot(getWaveHeightFlat(posxz, iswater, istransparent), vec3(0.333)) * 1.0, 0.0, 1.0);
	vec2 speckle = vec2(fract(sin(dot(uv.st, vec2(18.9898f, 28.633f))) * 4378.5453f) - 0.5) * mult * 0.1* wDepth;
	
	vec3 color = texture2D(gcolor, uv.st + speckle, 0.0).rgb / 12.0;
	for (int i = 0; i < 12; i++) color += texture2D(gcolor, (uv.st + (blurOffsets[i] * mult * wDepth)  + speckle) , 0.0).rgb / 12.0;
	
	return color;
}

#ifdef WATER_REFRACT

void waterRefraction(inout vec3 color, vec3 fragpos) {

	vec2 coord1;
	vec2 coord2;
	vec2 coord3;

	float maskCoord1;
	float maskCoord2;
	float maskCoord3;

	vec3 refraction;

	waterRefractCoord(maskCoord1, maskCoord2, maskCoord3, coord1, coord2, coord3, refraction);

	vec3 rA;
		rA.x = waterBlur(coord1, fragpos).x * MAX_COLOR_RANGE;
		rA.y = waterBlur(coord2, fragpos).y * MAX_COLOR_RANGE;
		rA.z = waterBlur(coord3, fragpos).z * MAX_COLOR_RANGE;

	vec3 rB = color.rgb;

	refraction.r = rA.r * maskCoord1 + rB.r * (1.0 - maskCoord1);
	refraction.g = rA.g * maskCoord2 + rB.g * (1.0 - maskCoord2);
	refraction.b = rA.b * maskCoord3 + rB.b * (1.0 - maskCoord3);

	if (iswater > 0.9 || istransparent > 0.9)
		color = refraction;
		//color += abs(1-clamp(pixeldepth / 1.25,0.0,1.0));
}

#endif

vec3 getColorCorrection(vec3 color, bool land){

	color.rgb *= vec3(0.9,1.0,1.1);

	color.r *= COLOR_R_MULT;
	color.g *= COLOR_G_MULT;
	color.b *= COLOR_B_MULT;

	return color.rgb;
}

vec4 getShadowWorldPos(in float shadowdepth, vec2 texcoord){

	vec4 sfragposition = nvec4(convertScreenSpaceToWorldSpace(texcoord.st,shadowdepth));
	
  if (isEyeInWater > 0.9)
   sfragposition.xy *= 0.817;

	vec4 sworldposition = vec4(0.0);
		sworldposition = gbufferModelViewInverse * sfragposition;

		sworldposition = shadowModelView * sworldposition;
		sworldposition = shadowProjection * sworldposition;
		sworldposition /= sworldposition.w;

	return sworldposition;

}

float getDistortFactor(vec4 worldposition){
	vec2 pos1 = abs(worldposition.xy * 1.165);

	float distb = pow(pow(pos1.x, 8.) + pow(pos1.y, 8.), 1.0 / 8.0);
	return (0.2) + distb * 0.8;
}

vec4 biasedShadows(vec4 worldposition){

	float distortFactor = getDistortFactor(worldposition);

	worldposition.xy /= distortFactor*0.97;
	worldposition = worldposition * vec4(0.5,0.5,0.2,0.5) + vec4(0.5,0.5,0.5,0.5);

	return worldposition;
}

float getWaterDepth(vec3 fragpos){

	vec3 uPos = vec3(.0);

	float uDepth = texture2D(depthtex1,refractionTexcoord()).x;
	uPos = nvec3(gbufferProjectionInverse * vec4(vec3(refractionTexcoord().xy,uDepth) * 2.0 - 1.0, 1.0));

	vec3 uVec = fragpos-uPos;

	float UNdotUP = abs(dot(normalize(uVec),normal2));
	float depth = sqrt(dot(uVec,uVec))*UNdotUP;

	//depth *= refractMask;

	return depth;
}

float calcWaterSSS(vec3 normal){

	const float wrap = 0.2;
	const float scatterWidth = 0.5;
	
	float NdotL = dot(normal2, lightVector);
	float NdotLWrap = (NdotL + wrap) / (1.0 + wrap);
	float scatter = smoothstep(0.0, scatterWidth, NdotLWrap) * smoothstep(scatterWidth * 2.0, scatterWidth, NdotLWrap);
	
	return scatter;
}

const vec2 offsets[25] = vec2[25](vec2(-0.4894566f,-0.3586783f),
									vec2(-0.1717194f,0.6272162f),
									vec2(-0.4709477f,-0.01774091f),
									vec2(-0.9910634f,0.03831699f),
									vec2(-0.2101292f,0.2034733f),
									vec2(-0.7889516f,-0.5671548f),
									vec2(-0.1037751f,-0.1583221f),
									vec2(-0.5728408f,0.3416965f),
									vec2(-0.1863332f,0.5697952f),
									vec2(0.3561834f,0.007138769f),
									vec2(0.2868255f,-0.5463203f),
									vec2(-0.4640967f,-0.8804076f),
									vec2(0.1969438f,0.6236954f),
									vec2(0.6999109f,0.6357007f),
									vec2(-0.3462536f,0.8966291f),
									vec2(0.172607f,0.2832828f),
									vec2(0.4149241f,0.8816f),
									vec2(0.136898f,-0.9716249f),
									vec2(-0.6272043f,0.6721309f),
									vec2(-0.8974028f,0.4271871f),
									vec2(0.5551881f,0.324069f),
									vec2(0.9487136f,0.2605085f),
									vec2(0.7140148f,-0.312601f),
									vec2(0.0440252f,0.9363738f),
									vec2(0.620311f,-0.6673451f)
									);

float shadowMask(bool doBlur, float size) {
	vec4 sworldposition = getShadowWorldPos(texture2D(depthtex0,texcoord.xy).x, texcoord.st);
	sworldposition = biasedShadows(sworldposition);
	
	float shadow = 0.0;
	if (doBlur) {
		for (int i = 0; i < 25; i++) {
			shadow += shadow2DLod(shadowtex0,vec3(sworldposition.st + offsets[i] * size/2048, sworldposition.z), size*0.1).x / 25;
		}
	}
	else shadow = shadow2D(shadowtex0,sworldposition.xyz).x;
	
	return shadow;
}

vec3 waterFog(vec3 color, vec3 fragpos, float fresnel) {
	
	float shadowMask = shadowMask(true, 40.0) * (1.0 - rainStrength);
	
	float SSS = pow(dot(normal2, lightVector), 2.0);
	float depthMap = (1.0 + pow(1.0-clamp(exp(-getWaterDepth(fragpos.xyz) * 1.0),0.0,1.0), 3.0)) / 2.0;
	depthMap *= (pow(reflectionSkyLight, 1.0));
	
	vec3 fogclr = vec3(0.0,0.15,0.3) * 0.03;
	fogclr = mix(fogclr.rgb, vec3(0.0,0.2,0.2) * 0.1, SSS * shadowMask * (0.5 + fresnel) / 1.5);
	
	if (iswater > 0.9) {
		color.rgb = pow(mix(pow(color.rgb, vec3(2.2)), fogclr * pow(sunlight / (TimeMidnight * 2.0 + 1.0), vec3(1.0)), depthMap), vec3(1.0/2.2));
	}
	
	return color.rgb;
}

bool getLand(sampler2D depth){
	vec2 coord1;
	vec2 coord2;
	vec2 coord3;

	float maskCoord1;
	float maskCoord2;
	float maskCoord3;

	vec3 refraction;
	
	return texture2D(depth, refractionTexcoord().st).r < comp;
}

#ifdef VOLUMETRIC_CLOUDS

// dirived from: http://devlog-martinsh.blogspot.nl/2011/03/glsl-8x8-bayer-matrix-dithering.html
float find_closest(vec2 pos)
{
 const int ditherPattern[64] = int[64](
  0, 32, 8, 40, 2, 34, 10, 42, /* 8x8 Bayer ordered dithering */
  48, 16, 56, 24, 50, 18, 58, 26, /* pattern. Each input pixel */
  12, 44, 4, 36, 14, 46, 6, 38, /* is scaled to the 0..63 range */
  60, 28, 52, 20, 62, 30, 54, 22, /* before looking in this table */
  3, 35, 11, 43, 1, 33, 9, 41, /* to determine the action. */
  51, 19, 59, 27, 49, 17, 57, 25,
  15, 47, 7, 39, 13, 45, 5, 37,
  63, 31, 55, 23, 61, 29, 53, 21);

 vec2 positon = vec2(0.0f);
      positon.x = floor(mod(texcoord.s * viewWidth, 8.0f));
	  positon.y = floor(mod(texcoord.t * viewHeight, 8.0f));

	int dither = ditherPattern[int(positon.x) + int(positon.y) * 8];

	return float(dither) / 64.0f;
}

float distx(float dist)
{
	return (far * (dist - near)) / (dist * (far - near));
}

float mod289(float x)
{
	return x - floor(x * (1.0 / 289.0)) * 289.0;
}

vec4 mod289(vec4 x)
{
	return x - floor(x * (1.0 / 289.0)) * 289.0;
}

vec4 perm(vec4 x)
{
	return mod289(((x * 34.0) + 1.0) * x);
}

float noise(vec3 p){
    vec3 a = floor(p);
    vec3 d = p - a;
    d = d * d * (3.0 - 2.0 * d);

    vec4 b = a.xxyy + vec4(0.0, 1.0, 0.0, 1.0);
    vec4 k1 = perm(b.xyxy);
    vec4 k2 = perm(k1.xyxy + b.zzww);

    vec4 c = k2 + a.zzzz;
    vec4 k3 = perm(c);
    vec4 k4 = perm(c + 1.0);

    vec4 o1 = fract(k3 * (1.0 / 41.0));
    vec4 o2 = fract(k4 * (1.0 / 41.0));

    vec4 o3 = o2 * d.z + o1 * (1.0 - d.z);
    vec2 o4 = o3.yw * d.x + o3.xz * (1.0 - d.x);

    return max(((o4.y * d.y + o4.x * (1.0 - d.y))),0.0);
}

float fbm(vec3 pos, float time){

	pos += time / 8.0;

	float f = 0.33, frq = 1.0, ap = 0.4;

    f += noise(pos*frq)*ap; frq *= 5.0; ap *= 0.05;
    f += noise(pos*frq)*ap; frq *= 1.0; ap *= 1.5;
    f += noise(pos*frq)*ap; frq *= 2.0; ap *= 1.5;
    f += noise(pos*frq)*ap;
	
	return f;

}

vec4 getClouds(in vec3 rayworldposition, float steps, vec3 fragpos, vec3 color){

	float height = 325.0;
	float cloudShapeMult = 2.0;
	
	float alhpa;
	vec3 cloudCol;
	
	cloudShapeMult = cloudShapeMult * (1.0 + (rayworldposition.y * 0.5));
			float cloudy = height + cloudShapeMult;
			float cloudy2 = height - cloudShapeMult;
			
			if (rayworldposition.y < cloudy2 || rayworldposition.y > cloudy)
				return vec4(0.0f);
			else {
			
			vec3 uv = rayworldposition.xyz / 100.0;
			float time = frameTimeCounter / 5.0;
			uv.x -= time * 0.02;
			
			float noise1  = fbm(uv, time);
			  
			float alt = 1.0 - clamp(sqrt(pow(rayworldposition.y - height,2.0)) / cloudShapeMult, 0.0, 1.0);
			  
			float coverage = 0.93 - rainStrength * 0.93;
			
			noise1 *= pow(alt * 1.7 * coverage,1.2);
			noise1 = pow(noise1, 50.0);
			
			if (noise1 < 0.001)
			{
				return vec4(0.0);
			}
			
			alhpa = noise1;
			
			float sunGlow = pow(max(dot(normalize(fragpos),lightVector),0.0),50.0) * transition_fading;
			
			vec3 lightColor = mix(sunlight, moonlight * 10.0, TimeMidnight) * 1.5;
				lightColor = mix(lightColor, pow(lightColor, vec3(2.2)),TimeSunrise + TimeSunset);
				lightColor = mix(lightColor,lightColor * 0.1, 0.1 * (min(1.0, noise1)));
				lightColor *= 1.0 + sunGlow;
			
			cloudCol = lightColor;
			
			return vec4(cloudCol * 0.01 * steps, alhpa);
		}
	
}

vec3 CloudRaymarch(float minDist){

			vec4 rayworldposition;

			vec4 rayfragposition = nvec4(convertScreenSpaceToWorldSpace(texcoord.st,distx(minDist)));

			rayworldposition = gbufferModelViewInverse * rayfragposition;
			rayworldposition /= rayworldposition.w;
			
			rayworldposition.xyz += cameraPosition.xyz;
			
			return rayworldposition.rgb;
}

vec3 rayMarching(vec3 color, bool land, vec3 fragpos, vec3 worldposition){

		vec3 wpos = worldposition;
		float worldDistance = sqrt(dot(wpos,wpos));
		
		float worldPositionSize = 500.0 / (16*16);
		
		vec4 cloudColor;
		vec4 clouds;

		float steps = far / 10.0;

		float ditherPattern = find_closest(texcoord.st);
		ditherPattern *= steps;

		float minDist = far - 10.0;
			minDist += ditherPattern;
			
		float weight = (minDist / steps);

		while (minDist > 0.0) {
		
			vec3 rayworldposition = CloudRaymarch(minDist);
			
			clouds += getClouds(rayworldposition.rgb * worldPositionSize, steps, fragpos, color);
			
			float marchDist = sqrt(dot((rayworldposition - cameraPosition) / worldPositionSize,(rayworldposition - cameraPosition) / worldPositionSize));
			  
			if (worldDistance < marchDist * worldPositionSize  && land)
				clouds.a *= 0.0;

			minDist = minDist - steps;
			
			cloudColor.rgb = clouds.rgb;
			cloudColor.a = clouds.a;
			
		}
		
		cloudColor.a /= weight;
		
		color.rgb = mix(color.rgb, cloudColor.rgb * 2.0, min(1.0, cloudColor.a));
	
		return color;
}

#endif

//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////

void main() {

	bool land = getLand(depthtex1);
	bool land2 = getLand(depthtex0);

	vec4 currentPosition = vec4(refractionTexcoord().x * 2.0 - 1.0, refractionTexcoord().y * 2.0 - 1.0, 2.0 * pixeldepth - 1.0, 1.0);

	vec4 fragposition = gbufferProjectionInverse * currentPosition;
		 fragposition = gbufferModelViewInverse * fragposition;
		 fragposition /= fragposition.w;
		 fragposition.xyz += cameraPosition;

	vec4 previousPosition = fragposition;
		 previousPosition.xyz -= previousCameraPosition;
		 previousPosition = gbufferPreviousModelView * previousPosition;
		 previousPosition = gbufferPreviousProjection * previousPosition;
		 previousPosition /= previousPosition.w;
		 
	vec3 fragpos = vec3(texcoord.st, texture2D(depthtex0, texcoord.st).r);
	fragpos = nvec3(gbufferProjectionInverse * nvec4(fragpos * 2.0 - 1.0));

	vec3 fragpos2 = vec3(refractionTexcoord().st, texture2D(depthtex1, refractionTexcoord().st).r);
	fragpos2 = nvec3(gbufferProjectionInverse * nvec4(fragpos2 * 2.0 - 1.0));
	
	if (isEyeInWater > 0.9) {
		fragpos.xy *= 0.831;
		fragpos2.xy *= 0.831;
	}


	vec4 worldposition = vec4(0.0);
		 worldposition = gbufferModelViewInverse * vec4(fragpos,1.0);

	#ifdef WATER_REFRACT
		waterRefraction(color,fragpos);
		//float wDepth = getDepth(pixeldepth) - getDepth(pixeldepth2);

		//float refMult = 1.0;
		//	refMult = clamp(wDepth,0.0,1.0);
		//	refMult /= getDepth(pixeldepth2);
		//	refMult *= (REFRACT_MULT/75);
		
		//if (iswater > 0.9) color.rgb = waterBlur(texcoord.st + getWaveHeightFlat(worldposition.xyz + cameraPosition.xyz, iswater, istransparent).xy * refMult, fragpos);
	#endif
	
	float depth = getWaterDepth(fragpos);


	#ifdef MOTIONBLUR
		color = getMotionblur(previousPosition, currentPosition, hand);
	#endif

	#ifdef Clouds
		if (!land)	color.rgb = drawCloud(fragpos2.xyz,color.rgb,1.0);
	#endif
	
	#ifdef Stars
		if (!land)	color.rgb = drawStar(fragpos2.xyz,color.rgb);
	#endif
	
	// setting up light color
		vec3 light_col = mix(pow(sunlight * (transition_fading * (1.0 - TimeMidnight)),vec3(4.4)),
		moonlight*50,
		moonVisibility * transition_fading * TimeMidnight * (1.0 - (TimeSunrise + TimeSunset)));
		
		light_col = mix(light_col,vec3(sqrt(dot(light_col,light_col)))*vec3(0.25,0.32,0.4),rainx);
		light_col = pow(light_col,mix(vec3(1.0 / 5.0),vec3(0.5), pow(TimeSunrise + TimeSunset,3.0) + TimeMidnight));
		light_col = mix(light_col, vec3(0.5), rainStrength);
	
		float normalDotEye = dot(normal2, normalize(fragpos));
		
		vec3 fresnel = pow(vec3(clamp(pow(1.0 + normalDotEye, 1.0),0.0,1.0)),vec3(1.0));
		fresnel.y = clamp(pow(1.0 + normalDotEye, 2.0),0.0,1.0);

		normalDotEye = dot(normal, normalize(fragpos));
			fresnel.z = clamp(pow(1.0 + normalDotEye, 1.0),0.0,1.0);
		
			fresnel.xz = pow(fresnel.xz,vec2(1.0));
		
		float depthMap = clamp(exp(-depth / 4.0),0.0,1.0);

		vec3 npos = normalize(fragpos2);
		vec3 reflectedVector = normalize(reflect(npos, normalize(normal2)));
		vec3 reflectedVector2 = normalize(reflect(npos, normalize(normal)));
		
		#ifdef WATER_DEPTH_FOG
			color.rgb = waterFog(color.rgb, fragpos, pow(fresnel.r, 1.0));
		#endif
		
		#ifdef FOG
		if (!land && land2)color.rgb = mix(color,getRainFogColor(),pow(rainx,4.0));
		#else
		if (!land)color.rgb = mix(color,getRainFogColor(),pow(rainx,4.0));
		#endif

	#ifdef REFLECTIONS
		
		light_col = light_col * mix(4.0,10.0,(TimeSunrise + TimeSunset) * transition_fading);

		vec4 reflection;

		vec3 getSky = getSkyReflection(mix(reflectedVector2, reflectedVector, istransparent + iswater));
		getSky *= mix(fresnel.z, fresnel.x, istransparent + iswater);
		
		float spec = sunSpec(sunVec, fragpos, normal2) * (1.0 - TimeMidnight) * (1.0 - isEyeInWater) * (1.0 - rainStrength) * float(pow(sky_lightmap, 50.0) > 0.1) * (istransparent + iswater);
		spec += sunSpec(sunVec, fragpos, normal) * (1.0 - TimeMidnight) * (1.0 - isEyeInWater) * (1.0 - rainStrength) * float(pow(sky_lightmap, 50.0) > 0.1) * (1.0 - (istransparent + iswater));
		spec *= shadowMask(false, 3.0);
		getSky += spec * light_col * 2.5;

		if (iswater > 0.9 || istransparent > 0.9) {
			#ifdef WATER_REFLECTIONS
				reflection = raytrace(fragpos, normal2, getSky, reflectedVector, fresnel.x);
				reflection.rgb = mix(getSky * reflectionSkyLight, reflection.rgb, reflection.a);
				reflection.a = REFLECTION_STRENGTH * fresnel.x;
				color.rgb = pow(color.rgb, vec3(2.2));
				//if (iswater > 0.9) color *= 1.0 - reflection.a;
				color.rgb += pow(reflection.rgb * (iswater + istransparent) * (1.0 - isEyeInWater) * reflection.a, vec3(2.2));
				color.rgb = pow(color.rgb, vec3(1.0/2.2));
			#endif
		} else {

			reflection = raytrace(fragpos, normal, getSky, reflectedVector2, fresnel.z);
			reflection.rgb = mix(getSky * reflectionSkyLight, reflection.rgb, reflection.a);
			reflection.a = 1.0;

			#ifdef RAIN_REFLECTIONS
				color.rgb = pow(color.rgb, vec3(2.2));
				color.rgb += pow(reflection.rgb*reflection.a*clamp(pow(iswet, 10.0), 0.0, 1.0)*(1.0-specmap) * (getRainPuddles(1.0, 0.0) + .05*(1-(getRainPuddles(1.0, 0.0))))* 15.0 *(1-iswater)*(1-isEyeInWater), vec3(2.2));
				color.rgb = pow(color.rgb, vec3(1.0/2.2));
			#endif

			#ifdef SPECULAR_REFLECTIONS
				color.rgb = pow(color.rgb, vec3(2.2));
				color.rgb += pow((reflection.rgb*fresnel.x*reflection.a)*specmap*(1-iswater), vec3(2.2));
				color.rgb = pow(color.rgb, vec3(1.0/2.2));
			#endif
		}

	#endif
	
	color = renderGaux2(color, refractionTexcoord());;
	
		vec3 vlFogColor = ambient_color;
	vlFogColor.g -= vlFogColor.g * 0.2;

	#ifdef GODRAYS
		color.rgb = getGodrays(fragpos);
	#endif

	#ifdef FOG
		color.rgb = getFog(color, land2, land, refractionTexcoord().st);
	#endif
	
	#ifdef VOLUMETRIC_CLOUDS
		vec3 threeDimClouds = rayMarching(color, land, fragpos2, worldposition.xyz);
		threeDimClouds = renderGaux2(threeDimClouds, refractionTexcoord());
		
		color = color.rgb = (threeDimClouds - renderGaux2(color, refractionTexcoord())) + color;
	#endif
	
	#ifdef VOLUMETRIC_LIGHT
		color.rgb = vlColor(vlFogColor, color.rgb, refractionTexcoord().st, fragpos2);
	#endif

	float depth_diff = clamp(pow(ld(pixeldepth2)*3.5,0.5),0.0,1.0);
	color.rgb = mix(color.rgb,clamp(vec3(0.024,0.040,0.08)/3.0*(1-TimeMidnight*(0.5/3.0)),0.0,1.0),depth_diff*isEyeInWater);


vec4 tpos = vec4(sunPosition,1.0)*gbufferProjection;
	 tpos = vec4(tpos.xyz/tpos.w,1.0);

vec2 pos1 = tpos.xy/tpos.z;
vec2 lightPos = pos1*0.5+0.5;

float visiblesun = 0.0;
float temp;
int nb = 0;

//calculate sun occlusion (only on one pixel)
if (texcoord.x < pw && texcoord.x < ph) {
	for (int i = 0; i < 2;i++) {
		for (int j = 0; j < 3 ;j++) {
		temp = texture2D(gaux1,lightPos + vec2(pw*(i-1.0)*7.0,ph*(j-1.0)*7.0)).g;
		visiblesun +=  1.0-float(temp > 0.04) ;
		nb += 1;
		}
	}
	visiblesun /= nb;

}

#ifdef COLOR_CORRECTION
	color.rgb = getColorCorrection(color,land);
#endif

//Dynamic Exposure
color *= mix(dynamicExposure()*1.0 + 1.0, 1.0, TimeMidnight);

//Saturation Correction
vec3 desat = vec3(dot(color.rgb, vec3(0.333)));
color.rgb = mix(color.rgb, desat, clamp(pow(desat, vec3(2.0)), 0.0, 1.0));
color.rgb = mix(color.rgb, desat * vec3(0.3,0.7,1.0), 1.0 - clamp(pow(desat, vec3(0.15)), 0.0, 1.0));

//color = mix(color, vec3(1.0),vec3(clamp(exp(-depth * 5.0),0.0,1.0)) * iswater * pow(getRainPuddles(20.0, frameTimeCounter / 2000.0),1.0));

/* DRAWBUFFERS:0 */

	gl_FragData[0] = vec4(color.rgb / MAX_COLOR_RANGE,visiblesun);

}
