#version 120

#include "/lib/colors.glsl"

varying vec4 texcoord;
varying vec3 sunlight;
varying vec3 moonlight;
varying vec3 lightVector;
varying vec3 ambient_color;
varying vec3 sunVec;
varying vec3 moonVec;
varying vec3 upVec;
varying vec3 cloudColor;

varying float sunVisibility;
varying float moonVisibility;

uniform int worldTime;
uniform float rainStrength;
uniform vec3 sunPosition;
uniform vec3 moonPosition;
uniform vec3 upPosition;

//raining
float rainx = clamp(rainStrength, 0.0f, 1.0f)/1.0f;


//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////
//////////////////////////////main//////////////////////////////

void main() {

		if (worldTime < 12700 || worldTime > 23250) {
		lightVector = normalize(sunPosition);
	}

	else {
		lightVector = normalize(moonPosition);
	}

	sunVec = normalize(sunPosition);
	moonVec = normalize(-sunPosition);
	upVec = normalize(upPosition);

	float SdotU = dot(sunVec,upVec);
	float MdotU = dot(moonVec,upVec);
	sunVisibility = pow(clamp(SdotU+0.1,0.0,0.1)/0.1,2.0);
	moonVisibility = pow(clamp(MdotU+0.1,0.0,0.1)/0.1,2.0);

	gl_Position = ftransform();

	texcoord = gl_MultiTexCoord0;
	
	sunlight = getSunlight(getTime(worldTime));

	sunlight.b *= 0.95;

	moonlight =  vec3(0.7,0.7,1.0)/2.0 * 0.012;
	
	ambient_color = getAmbient(getTime(worldTime));

	vec3 sky_color = vec3(0.1, 0.35, 1.);

	vec3 ambient_color2 = (sky_color)*2.;
	ambient_color2 = pow(normalize(ambient_color),vec3(1./2.2))*sqrt(dot(ambient_color,ambient_color));

	cloudColor = sunlight*sunVisibility*sqrt(dot(ambient_color2,ambient_color2)) + ambient_color2*(1-moonVisibility*0.8) + 2.0*moonlight*moonVisibility;
}
