#version 120

//ADJUSTABLE VARIABLES//

	#define BLOOM									//Makes glow effect on bright stuffs.

const bool gcolorMipmapEnabled = true;

//ADJUSTABLE VARIABLES//

/*--------------------------------*/
varying vec4 texcoord;
uniform sampler2D gcolor;
uniform float aspectRatio;
uniform float viewWidth;
uniform float viewHeight;
float pw = 1.0/ viewWidth;
float ph = 1.0/ viewHeight;
/*--------------------------------*/

vec3 makeBloom(float lod,vec2 offset){
vec3 bloom = vec3(0.0);
float scale = pow(2.0,lod);
vec2 coord = (texcoord.xy-offset)*scale;

if (coord.x > -0.1 && coord.y > -0.1 && coord.x < 1.1 && coord.y < 1.1){
for (int i = 0; i < 14; i++) {
	for (int j = 0; j < 14; j++) {
	float wg = pow((1.0-length(vec2(i-6,j-6))/8.0),2)*pow(0.5,0.5)*20.0;
	vec2 bcoord = (texcoord.xy-offset+vec2(i-6,j-6)*pw*vec2(1.0,aspectRatio))*scale;
	if (wg > 0) bloom += pow(texture2D(gcolor,bcoord).rgb,vec3(2.2))*wg;
	}
}
bloom /= 196;
}

return bloom;
}

//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////
//////////////////////////////VOID MAIN//////////////////////////////

void main() {
vec3 blur = vec3(0);
	#ifdef BLOOM
	 blur += pow(makeBloom(2,vec2(0,0)), vec3(1.1)) * 1.0;
	 blur += pow(makeBloom(3,vec2(0.3,0)), vec3(1.0)) * 1.1;
	 blur += pow(makeBloom(4,vec2(0,0.3)), vec3(1.0)) * 1.2;
	 blur += pow(makeBloom(5,vec2(0.1,0.3)), vec3(0.9)) * 1.4;
	 blur += pow(makeBloom(6,vec2(0.2,0.3)), vec3(0.8)) * 1.8;
	#endif
blur = clamp(pow(blur,vec3(1.0/2.2)),0.0,1.0);
/* DRAWBUFFERS:3 */
	gl_FragData[0] = vec4(blur,1.0);
}
