vec4 getTime(float timefract) {
	vec4 time = vec4(0.0);
	time.r = ((clamp(timefract, 23000.0f, 25000.0f) - 23000.0f) / 1000.0f) + (1.0f - (clamp(timefract, 0.0f, 2000.0f)/2000.0f));
	time.g = ((clamp(timefract, 0.0f, 2000.0f)) / 2000.0f) - ((clamp(timefract, 9000.0f, 12000.0f) - 9000.0f) / 3000.0f);
	time.b = ((clamp(timefract, 9000.0f, 12000.0f) - 9000.0f) / 3000.0f) - ((clamp(timefract, 12000.0f, 12750.0f) - 12000.0f) / 750.0f);
	time.a = ((clamp(timefract, 12000.0f, 12750.0f) - 12000.0f) / 750.0f) - ((clamp(timefract, 23000.0f, 24000.0f) - 23000.0f) / 1000.0f);
	
	return time;
}

vec3 getAmbient(vec4 time) {
	// Ambientcolor
	vec3 ambientColor_sunrise  = vec3(1.1, 1.2, 1.2) * 0.8 * time.r;
	vec3 ambientColor_noon     = vec3(0.7, 1.1, 2.0) * 4.5 * time.g;
	vec3 ambientColor_sunset   = vec3(1.1, 1.2, 1.2) * 0.8 * time.b;
	vec3 ambientColor_midnight = vec3(0.03, 0.15, 0.30) * 0.1 * time.a;

	return (ambientColor_sunrise + ambientColor_noon + ambientColor_sunset + ambientColor_midnight) * 0.07;
}

vec3 getSunlight(vec4 time) {
	// Sunlightcolor
	vec3 sunlightColor_sunrise  = vec3(2.5, 1.7, 0.8) * 0.5 * time.r;
	vec3 sunlightColor_noon     = vec3(2.5, 2.5, 2.5) * 1.0 * time.g;
	vec3 sunlightColor_sunset   = vec3(2.5, 1.5, 1.0) * 0.5 * time.b;
	vec3 sunlightColor_midnight = vec3(0.05, 0.1, 0.3) * 0.001 * time.a;

	return (sunlightColor_sunrise + sunlightColor_noon + sunlightColor_sunset + sunlightColor_midnight)*0.5;
}